dnl $Id: config.m4,v 1.18 2004/08/16 15:45:48 jay Exp $
dnl config.m4 for extension cryptopp

dnl Comments in this file start with the string 'dnl'.
dnl Remove where necessary. This file will not work
dnl without editing.

PHP_ARG_WITH(cryptopp, for cryptopp support,
[  --with-cryptopp[=DIR]             Include cryptopp support])

if test "$PHP_CRYPTOPP" != "no"; then

	if test "$CRYPTOPP_INCLUDES_DIR"; then
		SEARCH_PATH="$CRYPTOPP_INCLUDES_DIR"
	else
		SEARCH_PATH="/usr/local/include/cryptopp /usr/include/cryptopp"
	fi

	SEARCH_FOR="cryptlib.h"
	if test -r $PHP_CRYPTOPP; then
		CRYPTOPP_INCLUDES_DIR=$PHP_CRYPTOPP
	else
		AC_MSG_CHECKING(for cryptopp include files in default path)
		for i in $SEARCH_PATH ; do
			if test -r $i/$SEARCH_FOR; then
				FOUND_CRYPTOPP_INCLUDES_DIR=$i
				AC_MSG_RESULT(found $SEARCH_FOR in $i)
			fi
		done
	fi

	if test -z "$FOUND_CRYPTOPP_INCLUDES_DIR"; then
		AC_MSG_RESULT(not found)
		AC_MSG_ERROR(Please reinstall the cryptopp distribution)
	fi


	if test "$CRYPTOPP_LIB_DIR"; then
		SEARCH_PATH="$CRYPTOPP_LIB_DIR"
	else
		SEARCH_PATH="/usr/local/lib /usr/lib"
	fi

	LIBNAME=cryptopp
	LIBSYMBOL=cryptopp
	AC_MSG_CHECKING(for libcryptopp.a)
	for i in $SEARCH_PATH ; do
		if test -r $i/libcryptopp.a; then
			FOUND_CRYPTOPP_LIB_DIR=$i
			AC_MSG_RESULT(found in $i)
		fi
	done

	if test -z "$FOUND_CRYPTOPP_LIB_DIR"; then
		AC_MSG_RESULT(not found)
		AC_MSG_ERROR(Couldn't find libcryptopp.a; place libcryptopp.a in your library path)
	fi

	AC_DEFINE(HAVE_CRYPTOPP, 1, [ ])
	PHP_SUBST(CRYPTOPP_SHARED_LIBADD)
	PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $FOUND_CRYPTOPP_LIB_DIR, CRYPTOPP_SHARED_LIBADD)
	PHP_ADD_LIBRARY(stdc++, 1, CRYPTOPP_SHARED_LIBADD)

	PHP_NEW_EXTENSION(cryptopp, cryptopp.cpp    \
	                            jhelpers.cpp    \
	                            jsink.cpp       \
	                            \
	                            jbase.cpp       \
	                            jcipher.cpp     \
	                            jhash.cpp       \
	                            jhmac.cpp       \
	                            \
	                            j3way.cpp       \
	                            jaes.cpp        \
	                            jblowfish.cpp   \
	                            jcamellia.cpp   \
	                            jcast128.cpp    \
	                            jcast256.cpp    \
	                            jdes.cpp        \
	                            jdes_ede2.cpp   \
	                            jdes_ede3.cpp   \
	                            jdes_xex3.cpp   \
	                            jdiamond2.cpp    \
	                            jdiamond2lite.cpp\
	                            jgost.cpp       \
	                            jidea.cpp       \
	                            jmars.cpp       \
	                            jrc2.cpp        \
	                            jrc5.cpp        \
	                            jrc6.cpp        \
	                            jsafer.cpp      \
	                            jserpent.cpp    \
	                            jshacal2.cpp    \
	                            jshark.cpp      \
	                            jskipjack.cpp   \
	                            jsquare.cpp     \
	                            jtea.cpp        \
	                            jtwofish.cpp    \
	                            \
	                            jarc4.cpp       \
	                            jmarc4.cpp      \
	                            jpanamacipher.cpp \
	                            jseal.cpp, $ext_shared,,-I$FOUND_CRYPTOPP_INCLUDES_DIR -DNDEBUG -march=pentium3 -O3 -g -pipe -fomit-frame-pointer)
	PHP_REQUIRE_CXX()

fi

