/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jbase.cpp,v 1.8 2005/01/06 18:16:42 jay Exp $
*/

#include "jbase.h"

JBase::JBase()
{
	itsPlaintext = "";
}

string JBase::getPlaintext(const bool hex) const
{
	if (hex)
		return bin2hex(itsPlaintext);
	else
		return itsPlaintext;
}

string JBase::getCiphertext(const bool hex) const
{
	if (hex)
		return bin2hex(itsCiphertext);
	else
		return itsCiphertext;
}

string JBase::getKey(const bool hex) const
{
	if (hex)
		return bin2hex(itsKey);
	else
		return itsKey;
}

unsigned int JBase::getKeylength() const
{
	return itsKeylength;
}

void JBase::setPlaintext(const string plaintext, const bool hex)
{
	if (hex)
		itsPlaintext = hex2bin(plaintext);
	else
		itsPlaintext = plaintext;
}
	
void JBase::setCiphertext(const string ciphertext, const bool hex)
{
	if (hex)
		itsCiphertext = hex2bin(ciphertext);
	else
		itsCiphertext = ciphertext;
}

unsigned int JBase::setKey(const string key, const bool hex)
{
	if (hex)
		itsKey = hex2bin(key);
	else
		itsKey = key;

	itsKey.resize(setKeylength(itsKey.length()));

	return itsKeylength;
}

unsigned int JBase::setKeylength(const unsigned int keylength)
{
	itsKeylength = getValidKeylength(keylength);

	return itsKeylength;
}
