/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jbasiccipherinfo.cpp,v 1.5 2005/01/06 18:16:42 jay Exp $
*/

template <typename INFO, typename BASE>
unsigned int JBasicCipherInfo<INFO, BASE>::getValidKeylength(const unsigned int keylength) const
{
	return INFO::StaticGetValidKeyLength(keylength);
}

template <typename INFO, typename BASE>
unsigned int JBasicCipherInfo<INFO, BASE>::getDefaultKeylength() const
{
	return INFO::DEFAULT_KEYLENGTH;
}

template <typename INFO, typename BASE>
unsigned int JBasicCipherInfo<INFO, BASE>::getMaxKeylength() const
{
	return INFO::MAX_KEYLENGTH;
}

template <typename INFO, typename BASE>
unsigned int JBasicCipherInfo<INFO, BASE>::getMinKeylength() const
{
	return INFO::MIN_KEYLENGTH;
}

template <typename INFO, typename BASE>
unsigned int JBasicCipherInfo<INFO, BASE>::getMultKeylength() const
{
	if (INFO::MIN_KEYLENGTH == INFO::MAX_KEYLENGTH)
		return 0;
	else
		return INFO::StaticGetValidKeyLength(INFO::MIN_KEYLENGTH + 1) - INFO::MIN_KEYLENGTH;
}

template <typename INFO, typename BASE>
string JBasicCipherInfo<INFO, BASE>::getCipherName() const
{
	return INFO::StaticAlgorithmName();
}

template <typename INFO, typename BASE>
string JBasicCipherInfo<INFO, BASE>::getStaticCipherName()
{
	return INFO::StaticAlgorithmName();
}
