/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jhash.cpp,v 1.9 2005/01/06 18:16:42 jay Exp $
*/

#include "jhash.h"
 
JHash::JHash(string plaintext)
{
	itsPlaintext = plaintext;
	itsHashModule = NULL;
}

JHash::~JHash()
{
	if (itsHashModule != NULL)
		delete itsHashModule;
}

string JHash::getPlaintext() const
{
	return itsPlaintext;
}

string JHash::getHashtext(bool hex) const
{
	if (hex)
		return itsHashtext;
	else
		return hex2bin(itsHashtext);
}

unsigned int JHash::getDigestSize() const
{
	if (itsHashModule != NULL)
		return itsHashModule->DigestSize() * 2;
	else
		return 0;
}

void JHash::setPlaintext(const string plaintext)
{
	itsPlaintext = plaintext;
}

void JHash::setHashtext(const string hashtext)
{
	itsHashtext = hashtext;
}

