/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jmd4.h,v 1.6 2005/01/06 18:16:42 jay Exp $
*/

#ifndef __JMD4_H__
#define __JMD4_H__

#include "jconfig.h"

#if ENABLED_MD4 || ENABLED_MD4_HMAC

#if ENABLED_MD4
#include "jhash_t.h"
#endif

#if ENABLED_MD4_HMAC
#include "jhmac_t.h"
#endif

// Crypto++ headers...

#include "md4.h"

using namespace CryptoPP;

#if ENABLED_MD4
class JMD4 : public JHash_Template<MD4, MD4_HASH>
{
	public:
		JMD4(string plaintext = "") : JHash_Template<MD4, MD4_HASH>(plaintext) { }

		static string getHashName() { return "MD4"; }
};
#endif

#if ENABLED_MD4_HMAC
class JMD4_HMAC : public JHMAC_Template<MD4, MD4_HMAC>
{
	public:
		JMD4_HMAC(string plaintext = "") : JHMAC_Template<MD4, MD4_HMAC>(plaintext) { }

		static string getHashName() { return "MD4-HMAC"; }
};
#endif

#endif
#endif
