/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jpanamacipher.cpp,v 1.10 2005/01/06 18:16:42 jay Exp $
*/

#include "jpanamacipher.h"

#if ENABLED_PANAMA_LITTLE_ENDIAN_CIPHER
SymmetricCipher* JPanamaCipherLE::getEncryptionObject()
{
	return new PanamaCipher<LittleEndian>::Encryption((byte*) itsKey.data(), itsKeylength);
}

SymmetricCipher* JPanamaCipherLE::getDecryptionObject()
{
	return new PanamaCipher<LittleEndian>::Decryption((byte*) itsKey.data(), itsKeylength);
}
#endif

#if ENABLED_PANAMA_BIG_ENDIAN_CIPHER
SymmetricCipher* JPanamaCipherBE::getEncryptionObject()
{
	return new PanamaCipher<BigEndian>::Encryption((byte*) itsKey.data(), itsKeylength);
}

SymmetricCipher* JPanamaCipherBE::getDecryptionObject()
{
	return new PanamaCipher<BigEndian>::Decryption((byte*) itsKey.data(), itsKeylength);
}
#endif
