/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jrc2.cpp,v 1.9 2005/01/06 18:16:42 jay Exp $
*/

#include "jrc2.h"

#if ENABLED_RC2

JRC2::JRC2()
{
	itsEffectiveKeylength = RC2_Info::DEFAULT_EFFECTIVE_KEYLENGTH;
}

unsigned int JRC2::setEffectiveKeylength(const unsigned int keylength)
{
	if (keylength > RC2_Info::MAX_EFFECTIVE_KEYLENGTH)
		itsEffectiveKeylength = RC2_Info::MAX_EFFECTIVE_KEYLENGTH;
	else
		itsEffectiveKeylength = keylength;

	return itsEffectiveKeylength;
}

unsigned int JRC2::getEffectiveKeylength() const
{
	return itsEffectiveKeylength;
}

BlockCipher* JRC2::getEncryptionObject()
{
	return new RC2Encryption((byte*) itsKey.data(), itsKeylength, itsEffectiveKeylength);
}

BlockCipher* JRC2::getDecryptionObject()
{
	return new RC2Decryption((byte*) itsKey.data(), itsKeylength, itsEffectiveKeylength);
}

#endif
