/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jsafer.cpp,v 1.8 2005/01/06 18:16:42 jay Exp $
*/

#include "jsafer.h"

#if ENABLED_SAFER_K
BlockCipher* JSAFER_K::getEncryptionObject()
{
	return new SAFER_K_Encryption((byte*) itsKey.data(), itsKeylength, itsRounds);
}

BlockCipher* JSAFER_K::getDecryptionObject()
{
	return new SAFER_K_Decryption((byte*) itsKey.data(), itsKeylength, itsRounds);
}
#endif

#if ENABLED_SAFER_SK
BlockCipher* JSAFER_SK::getEncryptionObject()
{
	return new SAFER_SK_Encryption((byte*) itsKey.data(), itsKeylength, itsRounds);
}

BlockCipher* JSAFER_SK::getDecryptionObject()
{
	return new SAFER_SK_Decryption((byte*) itsKey.data(), itsKeylength, itsRounds);
}
#endif
