/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jsafer.h,v 1.9 2005/01/06 18:16:43 jay Exp $
*/

#ifndef __JSAFER_H__
#define __JSAFER_H__

#include "jconfig.h"

#if ENABLED_SAFER_K || ENABLED_SAFER_SAFER_SK

#include "jcipher_t.h"

// Crypto++ headers...

#include "safer.h"

using namespace CryptoPP;

#if ENABLED_SAFER_K
class JSAFER_K : public JCipher_Template<SAFER_K_Info, SAFER_K_CIPHER, 6, 1, 13>
{
	protected:
		BlockCipher* getEncryptionObject();
		BlockCipher* getDecryptionObject();
};
#endif

#if ENABLED_SAFER_SK
class JSAFER_SK : public JCipher_Template<SAFER_SK_Info, SAFER_SK_CIPHER, 6, 1, 13>
{
	protected:
		BlockCipher* getEncryptionObject();
		BlockCipher* getDecryptionObject();
};
#endif

#endif
#endif
