/*
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2005 J Smith <dark_panda@hushmail.com>            |
   | Crypto++ sources (not included) copyright (c) 1995-2003 Wei Dai      |
   +----------------------------------------------------------------------+
   | Check out COPYING for the exact license.                             |
   +----------------------------------------------------------------------+

$Id: jseal.cpp,v 1.10 2005/01/06 18:16:43 jay Exp $
*/

#include "jseal.h"

#if ENABLED_SEAL_LITTLE_ENDIAN
SymmetricCipher* JSEAL_LE::getEncryptionObject()
{
	return new SEAL<LittleEndian>::Encryption((byte*) itsKey.data(), itsKey.length(), NULL);
}

SymmetricCipher* JSEAL_LE::getDecryptionObject()
{
	return getEncryptionObject();
}
#endif

#if ENABLED_SEAL_BIG_ENDIAN
SymmetricCipher* JSEAL_BE::getEncryptionObject()
{
	return new SEAL<BigEndian>::Encryption((byte*) itsKey.data(), itsKey.length(), NULL);
}

SymmetricCipher* JSEAL_BE::getDecryptionObject()
{
	return getEncryptionObject();
}
#endif
