--TEST--
Running Panama hash tests
--SKIPIF--
<?php if (!extension_loaded("cryptopp") || !@cryptopp_hash_enabled(CRYPTOPP_HASH_PANAMA)) die("skip"); ?>
--POST--
--GET--
--FILE--
<?php

require_once("tests.php");

print "Panama tests:\n\n";

print "Little endian:\n";
runhashtest(CRYPTOPP_HASH_PANAMA_LITTLE_ENDIAN, "", strtoupper("aa0cc954d757d7ac7779ca3342334ca471abd47d5952ac91ed837ecd5b16922b"));
runhashtest(CRYPTOPP_HASH_PANAMA_LITTLE_ENDIAN, "The quick brown fox jumps over the lazy dog", strtoupper("5f5ca355b90ac622b0aa7e654ef5f27e9e75111415b48b8afe3add1c6b89cba1"));

print "\n\nBig endian:\n";
runhashtest(CRYPTOPP_HASH_PANAMA_BIG_ENDIAN, "", strtoupper("e81aa04523532dd7267e5c5bc3ba0e289837a62ba032350351980e960a84b0af"));
runhashtest(CRYPTOPP_HASH_PANAMA_BIG_ENDIAN, "The quick brown fox jumps over the lazy dog", strtoupper("8fa7dadce0110f979a0b795e76b2c25628d8bda88747758149c42e3bc13f85bc"));

?>
--EXPECTF--
%s ZE2 objects

Panama tests:

Little endian:
passed:		AA0CC954D757D7AC7779CA3342334CA471ABD47D5952AC91ED837ECD5B16922B
passed:	The quick brown fox jumps over the lazy dog	5F5CA355B90AC622B0AA7E654EF5F27E9E75111415B48B8AFE3ADD1C6B89CBA1


Big endian:
passed:		E81AA04523532DD7267E5C5BC3BA0E289837A62BA032350351980E960A84B0AF
passed:	The quick brown fox jumps over the lazy dog	8FA7DADCE0110F979A0B795E76B2C25628D8BDA88747758149C42E3BC13F85BC
